# Deep dive in content-based filtering algorithms

In this directory, notebooks are provided to give a deep dive of content-based filtering recommendation algorithms. The notebooks make use of the utility functions ([recommenders](../../recommenders)) available in the repo.

| Notebook | Environment | Description |
| --- | --- | --- |
| [dkn_deep_dive](dkn_deep_dive.ipynb) | Python GPU | Deep dive into DKN algorithm for news recommendation. |
| [mmlspark_lightgbm_criteo](mmlspark_lightgbm_criteo.ipynb) | PySpark | LightGBM gradient boosting tree algorithm implementation in MML Spark with Criteo dataset.
| [vowpal_wabbit_deep_dive](vowpal_wabbit_deep_dive.ipynb) | Python CPU | Deep dive into using Vowpal Wabbit for regression and matrix factorization.

Details on model training are best found inside each notebook.
