# Deep dive in hybrid algorithms

In this directory, notebooks are provided to give a deep dive of hybrid recommendation algorithms. The notebooks make use of the utility functions ([recommenders](../../recommenders)) available in the repo.

| Notebook | Environment | Description |
| --- | --- | --- |
| [fm_deep_dive](fm_deep_dive.ipynb) | Python CPU | Deep dive into factorization machine (FM) and field-aware FM (FFM) algorithm.
| [lightfm_deep_dive](lightfm_deep_dive.ipynb) | Python CPU | Deep dive into hybrid matrix factorisation model with LightFM.
| [ncf_deep_dive](ncf_deep_dive.ipynb) | Python CPU, GPU | Deep dive on a NCF algorithm and implementation.

Details on model training are best found inside each notebook.
